//-----------------------------------------
// LScript Item Animation template
//

@version 2.2
@warnings
@script motion
@name MuscleBone
@save relative

myversion=2.1;
//v2.1 fixes the initial settings of the bone setup
//v2 uses new id fixes in LW to make things more reliable.
//v1.7 all settings now can be set by an lscript
//v1.6 fixed minor interface glitch
//v1.5 added easier way to select target and offset
//v1.4 fixed saving of bones bug
//1.3 now fixes load from scene errors for items of different types. Should be completely
// robust
//1.2 now fixes load from scene errors.
// global values go here
//debug();
myobj=nil;
mymesh=nil;
myobjid=nil;
myidoffset=nil;
myitemtypes=@"Mesh","Light","Camera","Bone"@;

myset;
mytgt=1;
myxon=2;
myyon=3;
myzon=4;
myxsc=5;
myysc=6;
myzsc=7;
myzof=8;
ikchoice=true;

c,b0,t0;

create: obj      // with the Layout Object Agent argument
//create      // without the Layout Object Agent argument
{
    // one-time initialization takes place here

// Create a channel called MGMuscleBone, with an event callback called gettarget. 
// the procedure 'gettarget' is called everytime an event appears on the comring on our channel.
	myset[mytgt]=nil;
	myset[myxon]=true;
	myset[myyon]=true;
	myset[myzon]=true;
	myset[myxsc]=1.5;
	myset[myysc]=1.5;
	myset[myzsc]=1.0;
	myset[myzof]=1.5;

    comringattach("MGMakeMuscleBone","gettarget");
    myobj=obj;
    myobjid=myobj.id;

}

gettarget:event,data
{
// if the event's id is this object's id, do the following.
    if(event == myobjid)
    {
// decode the message, getting the data, an integer (indicated by the "i") and put it in myid
        myset=comringdecode(@"i#4","f#4"@,data);
        myset[mytgt]=getagentbyid(myset[mytgt]);
//        info("Index is:"+myid);
// all finished with the comring, so detach. The channel will be closed after this.
        comringdetach("MGMakeMuscleBone");
    }
    else
    {
        comringdetach("MGMakeMuscleBone");
    }
}

flags
{ 
    if (ikchoice==true)
    {
        return AFTERIK;
    } 
    else
    {
        return;
    }
} 

destroy
{
    // take care of final clean-up activities here
}

process: ma, frame, time
{
    // called each time the object's transformational values change

//StatusMsg("myobj "+myobj.id+" MyId"+myid);
//StatusMsg("myobj "+mytgt+":"+myidoffset);

//==================================================================

    if(myset[mytgt])
    {
        effectedby(myset[mytgt].name);

        extension=calculateUDF();
        myscale=ma.get(SCALING,time);
        if(myset[myxon])
            myxval=1/(pow(extension,myset[myxsc]));
        else
            myxval=1;
        if(myset[myyon])
            myyval=1/(pow(extension,myset[myysc]));
        else
            myyval=1;
        if(myset[myzon])
            myzval=(pow(extension,myset[myzsc]));
        else
            myzval=1;
//        StatusMsg("Ext:"+((1/extension)));//^myyscale.asNum()));

        ma.set(SCALING,<myscale.x*myxval,myscale.y*myyval,myscale.z*myzval>);

        thingname=myset[mytgt].name;
    }
    else
        thingname="(none)";

    setdesc("MG Muscle Bone following "+thingname);
}

load: what,io
{
//debug();
    if(what == SCENEMODE)   // processing an ASCII scene file
    {

        comringdetach("MGMakeMuscleBone");//need to do this since Create is called during load. 

        scene=Scene();
        myloadversion = io.read();
        if (myloadversion.asNum() <= myversion)
        {   
            for(i=1;i<=3;i++)     // read x,y,z settings
            {
                myset[1 + i] = io.read().asInt();
            	myset[4 + i] = io.read().asNum();
            }
        	myset[myzof]=io.read().asNum();
            myobjid=io.read().asInt();
			if(myobjid=="0")
				return;
    		myitem=Mesh(myobjid.asInt());
    		if(!myitem)
    			myitem=Light(myobjid.asInt());
    		if(!myitem)
    			myitem=Camera(myobjid.asInt());
    		if(myitem)
    			myset[mytgt]= myitem;
        }
    }
}

//flags
//{
//    return(AFTERIK);
//}

save: what,io
{
    if(what == SCENEMODE)
    {
        io.writeln(myversion);
		for(i=1;i<=3;i++)
		{
        	io.writeln(myset[1+i]);
        	io.writeln(myset[4+i]);
  		}
        if(myyon)

        io.writeln(myset[myzof]);
        if (!myset[mytgt])
            io.writeln("0");
        else 
            io.writeln(myset[mytgt].id);

    }
}
//=================================================================================
options
{
    reqbegin("MGMuscleBone Ver: "+myversion);

    reqsize(250,270);

    t0 = ctltab("Controls","Information");

    c[mytgt] = ctlallitems("Target",myset[mytgt]);
	b1 = ctlbutton("Use current item",150,"GetItem");

    c[myxon] = ctlcheckbox("Scale X",myset[myxon]);
    c[myxsc] = ctlpercent("X Scale",myset[myxsc]);
    c[myyon] = ctlcheckbox("Scale Y",myset[myyon]);
    c[myysc] = ctlpercent("Y Scale",myset[myysc]);
    c[myzon] = ctlcheckbox("Scale Z",myset[myzon]);
    c[myzsc] = ctlpercent("Z Scale",myset[myzsc]);
    c[myzof] = ctlpercent("Target Z offset",myset[myzof]);
	b2 = ctlbutton("Get current offset",150,"GetOffset");

    t1=ctltext("Contact: mike@mikegreen.name"," ",
                "Target is the object driving the musclebone",
                "Target offset is an adjustment value");
    ctlposition(t1,30,40);

    ctlactive(c[myxon],"scalexonUDF",c[myxsc]);
    ctlactive(c[myyon],"scaleyonUDF",c[myysc]);
    ctlactive(c[myzon],"scalezonUDF",c[myzsc]);
    ctlrefresh(c[mytgt],"boneUDF");
    ctlrefresh(c[myxsc],"xscaleUDF");
    ctlrefresh(c[myysc],"yscaleUDF");
    ctlrefresh(c[myzsc],"zscaleUDF");
    ctlrefresh(c[myzof],"zoffsetUDF");
    ctlrefresh(t0,"tabUDF");

    ctlpage(1,b1,b2,c[1],c[2],c[3],c[4],c[5],c[6],c[7],c[8]);
    ctlpage(2,t1);
    reqopen();
}

tabUDF:value
{
    return (value);
}

scalexonUDF:value
{
    myset[myxon]=getvalue(c[myxon]);
    return (value);
}

scaleyonUDF:value
{
   myset[myyon]=getvalue(c[myyon]);
   return (value);
}

scalezonUDF:value
{
    myset[myzon]=getvalue(c[myzon]);
    return (value);
}

xscaleUDF:value
{
    myset[myxsc]=getvalue(c[myxsc]);
    
}

yscaleUDF:value
{
    myset[myysc]=getvalue(c[myysc]);
}

zscaleUDF:value
{
    myset[myzsc]=getvalue(c[myzsc]);
}

zoffsetUDF:value
{
    myset[myzof]=getvalue(c[myzof]);
}

//===============================================================================

GetItem
{
//debug();
	myitem=Scene().firstSelect();
	if(!myitem || myitem.id == myobj.id)
		return;
	myset[mytgt]=myitem;
	reqabort();
	options();
}

boneUDF:value
{
//debug();     
    myitem=getvalue(c[mytgt]);
    if (myitem)
    {
      myset[mytgt]=myitem;
    }
    else
    {
        myset[mytgt]=nil;
    }
}

GetOffset
{
	if(!myobj || !myset[mytgt])
		return;
    mypos=myobj.param(WPOSITION,Scene().currenttime);
    mytgtpos=myset[mytgt].param(WPOSITION,Scene().currenttime);
    mylength=vmag(mytgtpos-mypos);
    if(myobj.genus==BONE)
        myrest=myobj.restlength;
    else
        myrest=1;

    extension=mylength/myrest;
    if(extension==0)
        extension=0.1;
	setvalue(c[myzof],extension);
}

calculateUDF
{
//debug();
    mypos=myobj.param(WPOSITION,Scene().currenttime);

    mytgtpos=myset[mytgt].param(WPOSITION,Scene().currenttime);
//    StatusMsg("Mypos"+mypos+" tgt"+mytgtpos);//^myyscale.asNum()));

    mylength=sqrt(pow((mytgtpos.x-mypos.x),2)+pow((mytgtpos.y-mypos.y),2)+pow((mytgtpos.z-mypos.z),2));
//    StatusMsg("mypos:"+mypos+"tgtpos"+mytgtpos+"Mylength"+mylength);
    if(myobj.genus==BONE)
        myrest=myobj.restlength;
    else if(myobj.genus==MESH && !myobj.null)
    {
//        myvec=myobj.position();
//        myrest=vmag(myvec[1],myvec[2]);
        myrest=1;        
    }
    else
        myrest=1;

    if(myset[myzof]!=0)
        extension=mylength/myset[myzof]/myrest;
    else
        extension=mylength/myrest;
    if(extension==0)
        extension=0.1;
    return(extension);
    
}

getagentbyid:id
{
//debug();
    myitem=Mesh(id);
    if(!myitem)
    	myitem=Light(id);
    if(!myitem)
    	myitem=Camera(id);
    if(myitem)
    	return(myitem);
    else
    	return (nil);
    
}























